%define _disable_ld_no_undefined 1

%define	major	1

%define	oldlib	%mklibname xfs %{major}
%define	olddev	%mklibname xfs -d
%define	oldstat	%mklibname xfs -d -s

%define	libname	%mklibname handle %{major}
%define	devname	%mklibname handle -d
%define	statname %mklibname handle -d -s

%bcond_without	uclibc

Name:		xfsprogs
Version:	3.1.8
Release:	2
Summary:	Utilities for managing the XFS filesystem
Source0:	ftp://oss.sgi.com/projects/xfs/cmd_tars//%{name}-%{version}.tar.gz
Patch1:		xfsprogs-2.9.8-fix-underlinking.patch
Patch2:		xfsprogs-2.10.2-format_not_a_string_literal_and_no_format_arguments.diff
Patch3:		xfsprogs-3.1.8-drop-aio-check.patch
Patch4:		xfsprogs-use-posix-signal-api.patch
License:	GPLv2
Group:		System/Kernel and hardware
BuildRequires:	pkgconfig(ext2fs)
BuildRequires:	libtool
BuildRequires:	pkgconfig(uuid)
BuildRequires:	readline-devel
%if %{with uclibc}
BuildRequires:	uClibc-devel >= 0.9.33.2-16
%endif
URL:		http://oss.sgi.com/projects/xfs/
Requires:	common-licenses
Conflicts:	xfsdump < 3.0.0

%description
A set of commands to use the XFS filesystem, including mkfs.xfs.

XFS is a high performance journaling filesystem which originated
on the SGI IRIX platform.  It is completely multi-threaded, can
support large files and large filesystems, extended attributes,
variable block sizes, is extent based, and makes extensive use of
Btrees (directories, extents, free space) to aid both performance
and scalability.

Refer to the documentation at http://oss.sgi.com/projects/xfs/
for complete details.  This implementation is on-disk compatible
with the IRIX version of XFS.

%package -n	uclibc-%{name}
Summary:	Utilities for managing the XFS filesystem (uClibc build)
Group:		System/Kernel and hardware

%description -n	uclibc-%{name}
A set of commands to use the XFS filesystem, including mkfs.xfs.

XFS is a high performance journaling filesystem which originated
on the SGI IRIX platform.  It is completely multi-threaded, can
support large files and large filesystems, extended attributes,
variable block sizes, is extent based, and makes extensive use of
Btrees (directories, extents, free space) to aid both performance
and scalability.

Refer to the documentation at http://oss.sgi.com/projects/xfs/
for complete details.  This implementation is on-disk compatible
with the IRIX version of XFS.

%package -n	%{libname}
Summary:	Main library for xfsprogs
Group:		System/Libraries
License:	LGPLv2.1+
%rename		%{oldlib}

%description -n	%{libname}
This package contains the library needed to run programs dynamically
linked with libhandle.

%package -n	uclibc-%{libname}
Summary:	Main library for xfsprogs (uClibc build)
Group:		System/Libraries
License:	LGPLv2.1+

%description -n	uclibc-%{libname}
This package contains the library needed to run programs dynamically
linked with libhandle.

%package -n	%{devname}
Summary:	XFS filesystem-specific libraries and headers
Group:		Development/C
License:	LGPLv2.1+
Requires:	%{libname} = %{EVRD}
%if %{with uclibc}
Requires:	uclibc-%{libname} = %{version}
%endif
# For uuid/uuid.h included in /usr/include/xfs/linux.h
Requires:	libuuid-devel
%rename		%{olddev}
Provides:	%{name}-devel = %{EVRD}

%description -n	%{devname}
%{devname} contains the libraries and header files needed to
develop XFS filesystem-specific programs.

You should install %{devname} if you want to develop XFS
filesystem-specific programs, If you install %{devname}, you'll
also want to install xfsprogs.

%package -n	%{statname}
Summary:	XFS filesystem-specific static libraries
Group:		Development/C
License:	LGPLv2.1+
Requires:	%{devname} = %{version}
%rename		%{oldstat}
Provides:	%{name}-static-devel = %{EVRD}

%description -n	%{statname}
%{devname} contains the static libraries needed to
develop XFS filesystem-specific programs.

You should install %{statname} if you want to develop XFS
filesystem-specific programs, If you install %{statname}, you'll
also want to install xfsprogs.

%prep
%setup -q
%patch1 -p1 -b .underlinking
%patch2 -p0 -b .format_not_a_string_literal_and_no_format_arguments
%patch3 -p1 -b .noaio~
%patch4 -p1 -b .posix_sig~

%if %{with uclibc}
mkdir .uclibc
pushd .uclibc
cp -a ../* .
popd
%endif

%build
%if %{with uclibc}
pushd .uclibc
export DEBUG="-DNDEBUG"

%uclibc_configure \
		OPTIMIZER="%{uclibc_cflags}" \
		--libdir=%{uclibc_root}/%{_lib} \
		--prefix=%{uclibc_root} \
		--exec-prefix=%{uclibc_root} \
		--libexecdir=%{uclibc_root}%{_libdir} \
		--sbindir=%{uclibc_root}/sbin \
		--enable-gettext=yes \
		--enable-editline=no \
		--enable-shared=yes \
		--enable-readline=yes

%make DEBUG=-DNDEBUG || make DEBUG=-DNDEBUG 
popd
%endif

export DEBUG="-DNDEBUG"
export OPTIMIZER="%{optflags}"

%configure2_5x	--libdir=/%{_lib} \
		--libexecdir=%{_libdir} \
		--sbindir=/sbin \
		--bindir=/usr/sbin \
		--enable-gettext=yes \
		--enable-editline=no \
		--enable-shared=yes \
		--enable-readine=yes

make DEBUG=-DNDEBUG OPTIMIZER="%{optflags}"

%install
%if %{with uclibc}
make -C .uclibc install DIST_ROOT=%{buildroot}
make -C .uclibc install-dev DIST_ROOT=%{buildroot}
install -d %{buildroot}%{uclibc_root}%{_libdir}
rm %{buildroot}%{uclibc_root}/%{_lib}/libhandle.so
ln -sr %{buildroot}/%{uclibc_root}/%{_lib}/libhandle.so.%{major}.* %{buildroot}%{uclibc_root}%{_libdir}/libhandle.so
mv %{buildroot}%{uclibc_root}/%{_lib}/libhandle.a %{buildroot}%{uclibc_root}%{_libdir}/libhandle.a
chmod +x %{buildroot}/%{uclibc_root}/%{_lib}/libhandle.so.%{major}*
%endif

make install DIST_ROOT=%{buildroot}/
make install-dev DIST_ROOT=%{buildroot}/

install -d %{buildroot}%{_libdir}
rm %{buildroot}/%{_lib}/libhandle.so
ln -sr %{buildroot}/%{_lib}/libhandle.so.%{major}.* %{buildroot}%{_libdir}/libhandle.so
mv %{buildroot}/%{_lib}/libhandle.a %{buildroot}%{_libdir}/libhandle.a
chmod +x %{buildroot}/%{_lib}/libhandle.so.%{major}*

# nuke files already packaged as %doc
rm -r %{buildroot}%{_datadir}/doc/xfsprogs/
%find_lang %{name}

%files -f %{name}.lang
%doc doc/CHANGES.gz doc/CREDITS README
/sbin/xfs_admin
/sbin/xfs_bmap
/sbin/xfs_check
/sbin/xfs_copy
/sbin/xfs_db
/sbin/xfs_freeze
/sbin/xfs_growfs
/sbin/xfs_info
/sbin/xfs_io
/sbin/xfs_logprint
/sbin/xfs_mkfile
/sbin/xfs_ncheck
/sbin/xfs_quota
/sbin/xfs_rtcp
/sbin/xfs_mdrestore
/sbin/xfs_metadump
/sbin/xfs_estimate
/sbin/xfs_fsr

/sbin/fsck.xfs
/sbin/mkfs.xfs
/sbin/xfs_repair
%{_mandir}/man[85]/*

%if %{with uclibc}
%files -n uclibc-%{name}
%{uclibc_root}/sbin/xfs_admin
%{uclibc_root}/sbin/xfs_bmap
%{uclibc_root}/sbin/xfs_check
%{uclibc_root}/sbin/xfs_copy
%{uclibc_root}/sbin/xfs_db
%{uclibc_root}/sbin/xfs_freeze
%{uclibc_root}/sbin/xfs_growfs
%{uclibc_root}/sbin/xfs_info
%{uclibc_root}/sbin/xfs_io
%{uclibc_root}/sbin/xfs_logprint
%{uclibc_root}/sbin/xfs_mkfile
%{uclibc_root}/sbin/xfs_ncheck
%{uclibc_root}/sbin/xfs_quota
%{uclibc_root}/sbin/xfs_rtcp
%{uclibc_root}/sbin/xfs_mdrestore
%{uclibc_root}/sbin/xfs_metadump
%{uclibc_root}/sbin/xfs_estimate
%{uclibc_root}/sbin/xfs_fsr

%{uclibc_root}/sbin/fsck.xfs
%{uclibc_root}/sbin/mkfs.xfs
%{uclibc_root}/sbin/xfs_repair
%endif

%files -n %{libname}
%doc README
/%{_lib}/libhandle.so.%{major}*

%if %{with uclibc}
%files -n uclibc-%{libname}
%{uclibc_root}/%{_lib}/libhandle.so.%{major}*
%endif

%files -n %{devname}
%doc README
%{_libdir}/libhandle.so
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libhandle.so
%endif
%{_includedir}/xfs
%{_mandir}/man3/*

%files -n %{statname}
%{_libdir}/libhandle.a
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libhandle.a
%endif


%changelog
* Sun Oct 28 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 3.1.8-2
+ Revision: 820209
- workaround parallel build breakage
- enable readline support
- drop libintl link patch, libc now automatically pulls it in for us on demand
- use %%uclibc_configure macro
- make sure libhandle.so symlink & libhandle.a static library gets installed
  under %%{_libdir}
- do uclibc build

* Fri Mar 23 2012 Bernhard Rosenkraenzer <bero@bero.eu> 3.1.8-1
+ Revision: 786363
- Update to 3.1.8

* Wed Mar 07 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 3.1.5-2
+ Revision: 782761
- fix buildrequires
- fix shared-lib-not-executable
- specify license properly for individual packages and loose the 'COPYING' file
- use %%{EVRD} macro
- rename library packages to libhandle to be consistent with library name
- drop excessive provides and ancient obsoletes
- cleanups

* Fri Apr 01 2011 Funda Wang <fwang@mandriva.org> 3.1.5-1
+ Revision: 649527
- update to new version 3.1.5

* Wed Mar 09 2011 Oden Eriksson <oeriksson@mandriva.com> 3.1.4-1
+ Revision: 643005
- 3.1.4
- use _disable_ld_no_undefined as it's simply too borked

* Tue Jun 15 2010 Thomas Backlund <tmb@mandriva.org> 3.1.2-1mnb2
+ Revision: 548119
- update to 3.1.2 (bugfix release)

* Sat Jan 30 2010 Funda Wang <fwang@mandriva.org> 3.1.1-1mnb2
+ Revision: 498439
- update to new version 3.1.1

* Sun Jan 17 2010 Funda Wang <fwang@mandriva.org> 3.1.0-1mnb2
+ Revision: 492564
- new version 3.1.0
- drop lazy-count patch, merged upstream

* Fri Dec 25 2009 Pascal Terjan <pterjan@mandriva.org> 3.0.3-3mnb2
+ Revision: 482287
- uuid/uuid.h is in libuuid-devel

* Thu Dec 10 2009 Pascal Terjan <pterjan@mandriva.org> 3.0.3-2mnb2
+ Revision: 475944
- -devel requires uuid/uuid.h

* Fri Sep 04 2009 Frederik Himpe <fhimpe@mandriva.org> 3.0.3-1mnb2
+ Revision: 431463
- Fix BuildRequires
- update to new version 3.0.3

* Wed May 06 2009 Frederik Himpe <fhimpe@mandriva.org> 3.0.1-1mnb2
+ Revision: 372723
- Update to new version 3.0.1
- Remove perl hack and autoconf: not needed

* Thu Feb 05 2009 Frederik Himpe <fhimpe@mandriva.org> 3.0.0-1mnb2
+ Revision: 337866
- Update to new version 3.0.0
- xfs_fsr moved from xfsdump to xfsprogs, so conflict with older xfsdump

* Tue Dec 23 2008 Oden Eriksson <oeriksson@mandriva.com> 2.10.2-2mnb2
+ Revision: 317941
- fix build with -Werror=format-security (P2)

  + Frederik Himpe <fhimpe@mandriva.org>
    - Update to new version 2.10.2

* Fri Sep 05 2008 Frederik Himpe <fhimpe@mandriva.org> 2.10.1-1mnb2
+ Revision: 281334
- Update to new version 2.10.1

* Tue Aug 05 2008 Thierry Vignaud <tv@mandriva.org> 2.9.8-3mnb2
+ Revision: 263791
- patch 1: fix underlinking
- rebuild

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Thu Apr 24 2008 Frederik Himpe <fhimpe@mandriva.org> 2.9.8-2mnb1
+ Revision: 197307
- Add patch0: enables lazy-count by default in mkfs.xfs because it
  improves performance. It was enabled by default in earlier mkfsprogs
  versions, but upstream disabled it again, because it requires
  Linux >= 2.6.23

* Wed Apr 23 2008 Frederik Himpe <fhimpe@mandriva.org> 2.9.8-1mnb1
+ Revision: 196968
- New upstream version

* Tue Mar 18 2008 Toshihiro Yamagishi <toshihiro@turbolinux.co.jp> 2.9.6-2mnb1
+ Revision: 188566
- get rid of termcap and readline requirement.
  becaut the readline interface does not work at all.
  and termcap has been obsoleted.
  see the following url for get more info
  https://bugzilla.redhat.com/show_bug.cgi?id=223781

* Mon Feb 18 2008 Thierry Vignaud <tv@mandriva.org> 2.9.6-1mnb1
+ Revision: 170659
- replace %%mkrel with %%manbo_mkrel for Manbo Core 1

* Mon Feb 11 2008 Frederik Himpe <fhimpe@mandriva.org> 2.9.6-1mdv2008.1
+ Revision: 165465
- New upstream version

* Thu Feb 07 2008 Makoto Dei <makoto@turbolinux.co.jp> 2.9.5-2mdv2008.1
+ Revision: 163693
- [Manbo-Lab]
- added "Provides: xfsprogs-devel" to libxfs-devel package

* Sun Feb 03 2008 Frederik Himpe <fhimpe@mandriva.org> 2.9.5-1mdv2008.1
+ Revision: 161790
- New release

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Nov 10 2007 David Walluck <walluck@mandriva.org> 2.9.4-1mdv2008.1
+ Revision: 107381
- 2.9.4
- new lib policy
- add static lib package
- configure modification should not work: it operates on configure which is recreated

* Thu Aug 16 2007 Austin Acton <austin@mandriva.org> 2.9.3-1mdv2008.0
+ Revision: 64075
- remove prereq
- new version
- bzip source
- add extra binaries

* Thu Jun 07 2007 Anssi Hannula <anssi@mandriva.org> 2.8.21-2mdv2008.0
+ Revision: 36218
- rebuild with correct optflags

  + Christiaan Welvaart <spturtle@mandriva.org>
    - 2.8.21

* Tue Apr 17 2007 Andreas Hasenack <andreas@mandriva.com> 2.8.20-1mdv2007.1
+ Revision: 13536
- updated to version 2.8.20


* Mon Feb 12 2007 Giuseppe Ghibò <ghibo@mandriva.com> 2.8.18-1mdv2007.0
+ Revision: 118890
- Release 2.8.18-1.
- Import xfsprogs

* Sat Aug 26 2006 Giuseppe Ghib <ghibo@mandriva.com> 2.8.11-1mdv2007.0
- 2.8.11.

* Sun Jul 09 2006 Giuseppe Ghib <ghibo@mandriva.com> 2.8.4-1mdv2007.0
- 2.8.4.
- Added update patch for pl translation.

* Fri May 05 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 2.7.11-1mdk
- 2.7.11

* Wed Jan 11 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 2.6.36-4mdk
- add BuildRequires: libtool

* Sun Jan 01 2006 Mandriva Linux Team <http://www.mandrivaexpert.com/> 2.6.36-3mdk
- Rebuild

* Sun Aug 07 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 2.6.36-2mdk
- add BuildRequires: libreadline-devel libtermcap-devel

* Wed Aug 03 2005 Giuseppe Ghib <ghibo@mandriva.com> 2.6.36-1mdk
- 2.6.36.

* Mon May 24 2004 Giuseppe Ghib <ghibo@mandrakesoft.com> 2.6.13-1mdk
- 2.6.13.

* Fri Apr 30 2004 Juan Quintela <quintela@mandrakesoft.com> 2.6.10-1mdk
- 2.6.10.

* Thu Feb 26 2004 Thomas Backlund <tmb@mandrake.org> 2.6.3-1mdk
- update to 2.6.3
- done by Per yvind Karlsen
  * 2.6.2
  * drop prefix tag
  * cosmetics

